<template>
    <!-- Start Content-->
    <div class="container-fluid">
        <!--        <div id="app">
                    <v-header></v-header>
                    <router-view></router-view>
                </div>-->

        <div class="row">
            <div class="col-12">
                <div class="card-box">
                    <div class="row">
                        <div class="col-lg-8">

                        </div>
                        <div class="col-lg-4">
                            <div class="text-lg-right mt-3 mt-lg-0">
                                <router-link :to="{name: 'Product Upload'}" class="btn btn-danger waves-effect waves-light"><i class="mdi mdi-plus-circle mr-1"></i> Загрузить из файла</router-link>
                            </div>
                        </div><!-- end col-->
                    </div> <!-- end row -->
                </div> <!-- end card-box -->
            </div> <!-- end col-->
        </div>
        <!-- end row-->

        <form>

            <div class="row">
                <div class="col-lg-6">
                    <div class="card-box">
                        <h5 class="text-uppercase bg-light p-2 mt-0 mb-3">General</h5>

                        <div class="form-group mb-3">
                            <label for="product-name">Наименование товара <span class="text-danger">*</span></label>
                            <input type="text" id="product-name" name="product-name" class="form-control" placeholder="e.g : Apple iMac" ref="product_name">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-name">Баркод <span class="text-danger">*</span></label>
                            <input type="text" id="product-barcode" name="product-barcode" class="form-control" placeholder="e.g : Apple iMac" ref="product_barcode">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-name">Артикул (sku) <span class="text-danger">*</span></label>
                            <input type="text" id="product-sku" name="product-sku" class="form-control" placeholder="e.g : Apple iMac" ref="product_sku">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-model">Модель <span class="text-danger">*</span></label>
                            <input type="text" id="product-model" name="product-model" class="form-control" placeholder="e.g : Apple iMac" ref="product_model">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-category">Страна производства <span class="text-danger">*</span></label>
                            <select class="form-control select2" id="product-region" name="product-region" ref="product_region">
                               <option :value="region.id" v-for="region in pageData.regions">{{ region.name }}</option>
                            </select>
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-description">Product Description <span class="text-danger">*</span></label>
                            <textarea class="form-control" id="product-description" name="product-description" rows="5" placeholder="Please enter description" ref="product_description"></textarea>
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-category">Базовая категория <span class="text-danger">*</span></label>
                            <select class="form-control select2" id="product-base_category" name="product-base_category" v-model="selected" ref="product_base_category">
                                <option value="0">Выберите базовую категорию</option>
                                <option :value="category.id" v-for="category in baseCategories" :key="category.id">{{ category.name }}</option>
                            </select>
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-category">Категория <span class="text-danger">*</span></label>
                            <select class="form-control select2" id="product-category" name="product-category" v-model="selectedCategory" ref="product_category">
                                <option value="0">Выберите категорию</option>
                                <option :value="category.id" v-for="category in filteredProducts" :key="category.id">{{ category.name }}</option>
                            </select>
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-category">Сегмент <span class="text-danger">*</span></label>
                            <select class="form-control select2" multiple id="product-segment" name="product-segment[]" v-model="selected_segments">
                                <option value="low-priced">Эконом</option>
                                <option value="middle-priced">Средний</option>
                                <option value="high-priced">Высокий</option>
                                <option value="luxury">Премиум</option>
                            </select>
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-base_price">Базовая оптовая цена <span class="text-danger">*</span></label>
                            <input type="text" class="form-control" id="product-base_price" name="product-base_price" placeholder="Enter amount" ref="product_base_price">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-drop_price">Оптовая цена по дропшиппингу</label>
                            <input type="text" class="form-control" id="product-drop_price" name="product-drop_price" placeholder="Enter amount" ref="product_drop_price">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-discount">Скидка</label>
                            <input type="text" class="form-control" id="product-discount" name="product-discount" placeholder="5% или 500" ref="product_discount">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-price">РРЦ<span class="text-danger">*</span></label>
                            <input type="text" class="form-control" id="product-price" name="product-price" placeholder="Enter amount" ref="product_price">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-min_order">Минимальный заказ (шт) </label>
                            <input type="text" class="form-control" id="product-min_order" name="product-min_order" placeholder="Enter amount" ref="product_min_order">
                        </div>

                        <div class="form-group mb-3">
                            <label for="product-category">Цвет <span class="text-danger">*</span></label>
                            <select class="form-control select2" id="product-color" name="product-color" ref="product_color">
                                <option :value="color.value" v-for="color in pageData.colors">{{ color.title }}</option>
                            </select>
                        </div>
                        <div class="form-group mb-3">
                            <label for="product-sizes">Размеры <span class="text-danger">*</span></label>
                            <div class="form-group row mb-3" v-for="(size) in getCurrentSizes">
                                <label class="col-form-label">{{ size.title }}</label>
                                <div class="col-sm-2">
                                    <input type="text" :name="'product-sizes['+ size.value +']'" class="form-control" placeholder="1" @change="currentSizes($event)">
                                </div>
                                <label class="col-form-label">шт.</label>
                            </div>
                        </div>

                        <div class="form-group mb-3">
                            <label class="mb-2">Модификация товара (Выберите товар) <span class="text-danger">*</span></label>
                            <select class="form-control select2" id="product-modification" name="product-modification" ref="product_modification">
                                <option value="0">Выберите базовый товар</option>
                                <option :value="product.id" v-for="product in pageData.products">{{ product.name }}</option>
                            </select>
                        </div>

                        <div class="form-group mb-3">
                            <label class="mb-2">Статус <span class="text-danger">*</span></label>
                            <select class="form-control select2" id="product-status" name="product-status" ref="product_status">
                                <option :value="key" v-for="(status, key) in pageData.statuses">{{ status }}</option>
                            </select>
                        </div>
                    </div> <!-- end card-box -->
                </div> <!-- end col -->

                <div class="col-lg-6">

                    <div class="card-box">
                        <h5 class="text-uppercase mt-0 mb-3 bg-light p-2">Product Images</h5>

                        <input name="images[]" type="file" multiple ref="product_images"/>

                    </div> <!-- end col-->

                </div> <!-- end col-->
            </div>
            <!-- end row -->

            <div class="row">
                <div class="col-12">
                    <div class="text-center mb-3">
                        <button type="button" class="btn w-sm btn-light waves-effect">Cancel</button>
                        <button type="submit" class="btn w-sm btn-success waves-effect waves-light" @click.prevent="getFormValues()">Save</button>
                    </div>
                </div> <!-- end col -->
            </div>
            <!-- end row -->

        </form>

        <!-- file preview template -->
        <div class="d-none" id="uploadPreviewTemplate">
            <div class="card mt-1 mb-0 shadow-none border">
                <div class="p-2">
                    <div class="row align-items-center">
                        <div class="col-auto">
                            <img data-dz-thumbnail src="#" class="avatar-sm rounded bg-light" alt="">
                        </div>
                        <div class="col pl-0">
                            <a href="javascript:void(0);" class="text-muted font-weight-bold" data-dz-name></a>
                            <p class="mb-0" data-dz-size></p>
                        </div>
                        <div class="col-auto">
                            <!-- Button -->
                            <a href="" class="btn btn-link btn-lg text-muted" data-dz-remove>
                                <i class="dripicons-cross"></i>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div> <!-- container -->
</template>

<script>
import '/assets/libs/select2/select2.min.js'
import axios from 'axios'
import SpinnerComponent from "../../../components/SpinnerComponent";

export default {
    components: {SpinnerComponent},
    data() {
        return {
            pageData: {},
            selected: 0,
            currentItem: {},
            items: [],
            baseCategories: [],
            selectedCategory: 0,
            currentSelectedCategory: {},
            sizes: [],
            currentSelectedSizes: {},
            formData: {},
            selected_segments: []
        }
    },
    computed: {
        filteredProducts: function() {
            this.getCurrentCategory();
            this.items = [];
            this.isCategoryEmpty = true;

            for(let item in this.pageData.categories){
                if(this.pageData.categories[item]._lft > this.currentItem._lft && this.currentItem._rgt > this.pageData.categories[item]._rgt){
                    if(this.pageData.categories[item]._rgt - this.pageData.categories[item]._lft == 1){
                        this.items.push(this.pageData.categories[item]);
                    }
                }
            }

            if(this.items.length == 0)
                this.items.push(this.currentItem);

            return this.items;
        },
        getCurrentSizes: function(){
            this.getCurrentSelectedCategory();
            this.sizes = [];
            this.currentSelectedSizes = {};
            for(let size in this.pageData.sizes){
                if(this.pageData.sizes[size].category_type == this.currentSelectedCategory.type){
                    this.sizes.push(this.pageData.sizes[size]);
                }
            }
            return this.sizes;
        }
    },
    methods: {
        currentSizes(el){
            this.currentSelectedSizes[el.target.name] = el.target.value;
        },
        sendPageData(){
            axios.post('/api/v1/products/store', this.formData)
                .then(resp => {
                    alert(resp.data);
                })
                .catch(Error => function(){
                    alert(Error)
                });
        },
        getPageData(){
            axios.get('/api/v1/products/create')
                .then(resp => {
                    this.pageData = resp.data;
                    this.getBaseCategories();
                })
                .catch(Error => function(){
                    console.log(Error)
            });
        },
        getCurrentCategory(){
            for(let item in this.pageData.categories){
                if(this.pageData.categories[item].id == this.selected){
                    this.currentItem = this.pageData.categories[item];
                }
            }
        },
        getCurrentSelectedCategory(){
            for(let item in this.pageData.categories){
                if(this.pageData.categories[item].id == this.selectedCategory){
                    this.currentSelectedCategory = this.pageData.categories[item];
                }
            }
        },
        getBaseCategories(){
            this.baseCategories = [];
            for(let item in this.pageData.categories){
                if(this.pageData.categories[item].depth <= 3){
                    this.baseCategories.push(this.pageData.categories[item]);
                }
            }
        },
        getFormValues(){
            this.formData['product_name'] = this.$refs.product_name.value;
            this.formData['product_barcode'] = this.$refs.product_barcode.value;
            this.formData['product_sku'] = this.$refs.product_sku.value;
            this.formData['product_model'] = this.$refs.product_model.value;
            this.formData['product_region'] = this.$refs.product_region.value;
            this.formData['product_description'] = this.$refs.product_description.value;
            this.formData['product_base_category'] = this.$refs.product_base_category.value;
            this.formData['product_category'] = this.$refs.product_category.value;
            this.formData['product_segment'] = this.selected_segments;
            this.formData['product_base_price'] = this.$refs.product_base_price.value;
            this.formData['product_drop_price'] = this.$refs.product_drop_price.value;
            this.formData['product_discount'] = this.$refs.product_discount.value;
            this.formData['product_price'] = this.$refs.product_price.value;
            this.formData['product_min_order'] = this.$refs.product_min_order.value;
            this.formData['product_color'] = this.$refs.product_color.value;
            this.formData['product_modification'] = this.$refs.product_modification.value;
            this.formData['product_status'] = this.$refs.product_status.value;
            this.formData['product_images'] = this.$refs.product_images.value;
            this.formData['product_sizes'] = this.currentSelectedSizes;
            this.sendPageData();
        }
    },
    mounted: function(){
        this.getPageData();
        // Select2
        //$('.select2').select2();
    }
}
</script>

<style scoped>

</style>
